# This file is auto generated by `generate_declarations.py`. #AUTOGENERATED

from classiq.interface.model.quantum_function_declaration import (
    QuantumFunctionDeclaration,
)

QFT_STEP = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qft_step",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QFT = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qft",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QPE_FLEXIBLE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qpe_flexible",
    "param_decls": {},
    "port_declarations": {
        "phase": {
            "name": "phase",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "unitary_with_power": {
            "name": "unitary_with_power",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "classical_type": {
                        "kind": "int"
                    }
                }
            ],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "unitary_with_power",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "classical_type": {
                        "kind": "int"
                    }
                }
            ],
            "is_list": false
        },
        {
            "name": "phase",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "inout"
        }
    ]
}"""
)

QPE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qpe",
    "param_decls": {},
    "port_declarations": {
        "phase": {
            "name": "phase",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "unitary": {
            "name": "unitary",
            "positional_arg_declarations": [],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "unitary",
            "positional_arg_declarations": [],
            "is_list": false
        },
        {
            "name": "phase",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "inout"
        }
    ]
}"""
)

STANDARD_QPE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "standard_qpe",
    "param_decls": {
        "precision": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "phase": {
            "name": "phase",
            "size": {
                "expr": "precision"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "unitary": {
            "name": "unitary"
        }
    },
    "positional_arg_declarations": []
}"""
)

SINGLE_PAULI = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "single_pauli",
    "param_decls": {
        "slope": {
            "kind": "real"
        },
        "offset": {
            "kind": "real"
        }
    },
    "port_declarations": {
        "x": {
            "name": "x",
            "direction": "inout"
        },
        "q": {
            "name": "q",
            "size": {
                "expr": "1"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "q1_qfunc": {
            "name": "q1_qfunc",
            "param_decls": {
                "theta": {
                    "kind": "real"
                }
            },
            "port_declarations": {
                "target": {
                    "name": "target",
                    "size": {
                        "expr": "1"
                    },
                    "direction": "inout"
                }
            }
        }
    },
    "positional_arg_declarations": []
}"""
)

LINEAR_PAULI_ROTATIONS = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "linear_pauli_rotations",
    "param_decls": {
        "bases": {
            "kind": "list",
            "element_type": {
                "kind": "pauli"
            }
        },
        "slopes": {
            "kind": "list",
            "element_type": {
                "kind": "real"
            }
        },
        "offsets": {
            "kind": "list",
            "element_type": {
                "kind": "real"
            }
        }
    },
    "port_declarations": {
        "x": {
            "name": "x",
            "direction": "inout"
        },
        "q": {
            "name": "q",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

AMPLITUDE_ESTIMATION = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "amplitude_estimation",
    "param_decls": {
        "num_phase_qubits": {
            "kind": "int"
        },
        "num_unitary_qubits": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "phase_port": {
            "name": "phase_port",
            "quantum_type": {
                "kind": "qnum",
                "size": {
                    "expr": "num_phase_qubits"
                },
                "is_signed": {
                    "expr": "False"
                },
                "fraction_digits": {
                    "expr": "num_phase_qubits"
                }
            },
            "size": {
                "expr": "num_phase_qubits"
            },
            "direction": "output"
        },
        "unitary_port": {
            "name": "unitary_port",
            "size": {
                "expr": "num_unitary_qubits"
            },
            "direction": "output"
        }
    },
    "operand_declarations": {
        "sp_op": {
            "name": "sp_op",
            "param_decls": {
                "num_unitary_qubits": {
                    "kind": "int"
                }
            },
            "port_declarations": {
                "spq": {
                    "name": "spq",
                    "size": {
                        "expr": "num_unitary_qubits"
                    },
                    "direction": "inout"
                }
            }
        },
        "oracle_op": {
            "name": "oracle_op",
            "param_decls": {
                "num_unitary_qubits": {
                    "kind": "int"
                }
            },
            "port_declarations": {
                "oq": {
                    "name": "oq",
                    "size": {
                        "expr": "num_unitary_qubits"
                    },
                    "direction": "inout"
                }
            }
        }
    },
    "positional_arg_declarations": []
}"""
)

PHASE_ORACLE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "phase_oracle",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "predicate": {
            "name": "predicate",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                },
                {
                    "name": "arg1",
                    "quantum_type": {
                        "kind": "qbit"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "predicate",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                },
                {
                    "name": "arg1",
                    "quantum_type": {
                        "kind": "qbit"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        {
            "name": "target",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

REFLECT_ABOUT_ZERO = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "reflect_about_zero",
    "param_decls": {},
    "port_declarations": {
        "packed_vars": {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

GROVER_DIFFUSER = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "grover_diffuser",
    "param_decls": {},
    "port_declarations": {
        "packed_vars": {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "space_transform": {
            "name": "space_transform",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "space_transform",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

GROVER_OPERATOR = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "grover_operator",
    "param_decls": {},
    "port_declarations": {
        "packed_vars": {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "oracle": {
            "name": "oracle",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        "space_transform": {
            "name": "space_transform",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "oracle",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        {
            "name": "space_transform",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

GROVER_SEARCH = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "grover_search",
    "param_decls": {
        "reps": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "packed_vars": {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "oracle": {
            "name": "oracle",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        }
    },
    "positional_arg_declarations": [
        {
            "name": "reps",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "oracle",
            "positional_arg_declarations": [
                {
                    "name": "arg0",
                    "quantum_type": {
                        "length": null,
                        "kind": "qvec"
                    },
                    "direction": "inout"
                }
            ],
            "is_list": false
        },
        {
            "name": "packed_vars",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

HADAMARD_TRANSFORM = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "hadamard_transform",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

APPLY_TO_ALL = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "apply_to_all",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "gate_operand": {
            "name": "gate_operand",
            "port_declarations": {
                "target": {
                    "name": "target",
                    "size": {
                        "expr": "1"
                    },
                    "direction": "inout"
                }
            }
        }
    },
    "positional_arg_declarations": []
}"""
)

ALLOCATE_NUM = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "allocate_num",
    "param_decls": {
        "num_qubits": {
            "kind": "int"
        },
        "is_signed": {
            "kind": "bool"
        },
        "fraction_digits": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "out": {
            "name": "out",
            "quantum_type": {
                "kind": "qnum",
                "size": {
                    "expr": "num_qubits"
                },
                "is_signed": {
                    "expr": "is_signed"
                },
                "fraction_digits": {
                    "expr": "fraction_digits"
                }
            },
            "direction": "output"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QAOA_MIXER_LAYER = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qaoa_mixer_layer",
    "param_decls": {
        "b": {
            "kind": "real"
        }
    },
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QAOA_COST_LAYER = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qaoa_cost_layer",
    "param_decls": {
        "g": {
            "kind": "real"
        },
        "hamiltonian": {
            "kind": "list",
            "element_type": {
                "kind": "struct_instance",
                "name": "PauliTerm"
            }
        }
    },
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QAOA_LAYER = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qaoa_layer",
    "param_decls": {
        "g": {
            "kind": "real"
        },
        "b": {
            "kind": "real"
        },
        "hamiltonian": {
            "kind": "list",
            "element_type": {
                "kind": "struct_instance",
                "name": "PauliTerm"
            }
        }
    },
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QAOA_INIT = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qaoa_init",
    "param_decls": {},
    "port_declarations": {
        "target": {
            "name": "target",
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

QAOA_PENALTY = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "qaoa_penalty",
    "param_decls": {
        "num_qubits": {
            "kind": "int"
        },
        "params_list": {
            "kind": "list",
            "element_type": {
                "kind": "real"
            }
        },
        "hamiltonian": {
            "kind": "list",
            "element_type": {
                "kind": "struct_instance",
                "name": "PauliTerm"
            }
        }
    },
    "port_declarations": {
        "target": {
            "name": "target",
            "size": {
                "expr": "num_qubits"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": []
}"""
)

FULL_HEA = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "full_hea",
    "param_decls": {
        "num_qubits": {
            "kind": "int"
        },
        "is_parametrized": {
            "kind": "list",
            "element_type": {
                "kind": "int"
            }
        },
        "angle_params": {
            "kind": "list",
            "element_type": {
                "kind": "real"
            }
        },
        "connectivity_map": {
            "kind": "list",
            "element_type": {
                "kind": "list",
                "element_type": {
                    "kind": "int"
                }
            }
        },
        "reps": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "x": {
            "name": "x",
            "size": {
                "expr": "num_qubits"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {
        "operands_1qubit": {
            "name": "operands_1qubit",
            "param_decls": {
                "angle": {
                    "kind": "real"
                }
            },
            "port_declarations": {
                "q": {
                    "name": "q",
                    "size": {
                        "expr": "1"
                    },
                    "direction": "inout"
                }
            },
            "is_list": true
        },
        "operands_2qubit": {
            "name": "operands_2qubit",
            "param_decls": {
                "angle": {
                    "kind": "real"
                }
            },
            "port_declarations": {
                "q1": {
                    "name": "q1",
                    "size": {
                        "expr": "1"
                    },
                    "direction": "inout"
                },
                "q2": {
                    "name": "q2",
                    "size": {
                        "expr": "1"
                    },
                    "direction": "inout"
                }
            },
            "is_list": true
        }
    },
    "positional_arg_declarations": []
}"""
)

SWAP_TEST = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "swap_test",
    "param_decls": {},
    "port_declarations": {
        "state1": {
            "name": "state1",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        },
        "state2": {
            "name": "state2",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        },
        "test": {
            "name": "test",
            "quantum_type": {
                "kind": "qbit"
            },
            "direction": "output"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "state1",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        },
        {
            "name": "state2",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        },
        {
            "name": "test",
            "quantum_type": {
                "kind": "qbit"
            },
            "direction": "output"
        }
    ]
}"""
)

PREPARE_GHZ_STATE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "prepare_ghz_state",
    "param_decls": {
        "size": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "q": {
            "name": "q",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "output"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "size",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "q",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "output"
        }
    ]
}"""
)

PREPARE_EXPONENTIAL_STATE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "prepare_exponential_state",
    "param_decls": {
        "rate": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "q": {
            "name": "q",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "rate",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "q",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

PREPARE_BELL_STATE = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "prepare_bell_state",
    "param_decls": {
        "state_num": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "q": {
            "name": "q",
            "quantum_type": {
                "length": {
                    "expr": "2"
                },
                "kind": "qvec"
            },
            "direction": "output"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "state_num",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "q",
            "quantum_type": {
                "length": {
                    "expr": "2"
                },
                "kind": "qvec"
            },
            "direction": "output"
        }
    ]
}"""
)

INPLACE_PREPARE_INT = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "inplace_prepare_int",
    "param_decls": {
        "value": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "target": {
            "name": "target",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "value",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "target",
            "quantum_type": {
                "length": null,
                "kind": "qvec"
            },
            "direction": "inout"
        }
    ]
}"""
)

PREPARE_INT = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "prepare_int",
    "param_decls": {
        "value": {
            "kind": "int"
        }
    },
    "port_declarations": {
        "out": {
            "name": "out",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "output"
        }
    },
    "operand_declarations": {},
    "positional_arg_declarations": [
        {
            "name": "value",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "out",
            "quantum_type": {
                "kind": "qnum"
            },
            "direction": "output"
        }
    ]
}"""
)

SWITCH = QuantumFunctionDeclaration.parse_raw(
    """{
    "name": "switch",
    "param_decls": {
        "selector": {
            "kind": "int"
        }
    },
    "port_declarations": {},
    "operand_declarations": {
        "cases": {
            "name": "cases",
            "positional_arg_declarations": [],
            "is_list": true
        }
    },
    "positional_arg_declarations": [
        {
            "name": "selector",
            "classical_type": {
                "kind": "int"
            }
        },
        {
            "name": "cases",
            "positional_arg_declarations": [],
            "is_list": true
        }
    ]
}"""
)

__all__ = [
    "QFT_STEP",
    "QFT",
    "QPE_FLEXIBLE",
    "QPE",
    "STANDARD_QPE",
    "SINGLE_PAULI",
    "LINEAR_PAULI_ROTATIONS",
    "AMPLITUDE_ESTIMATION",
    "PHASE_ORACLE",
    "REFLECT_ABOUT_ZERO",
    "GROVER_DIFFUSER",
    "GROVER_OPERATOR",
    "GROVER_SEARCH",
    "HADAMARD_TRANSFORM",
    "APPLY_TO_ALL",
    "ALLOCATE_NUM",
    "QAOA_MIXER_LAYER",
    "QAOA_COST_LAYER",
    "QAOA_LAYER",
    "QAOA_INIT",
    "QAOA_PENALTY",
    "FULL_HEA",
    "SWAP_TEST",
    "PREPARE_GHZ_STATE",
    "PREPARE_EXPONENTIAL_STATE",
    "PREPARE_BELL_STATE",
    "INPLACE_PREPARE_INT",
    "PREPARE_INT",
    "SWITCH",
]
